<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:demo="http://www.hyfinity.com/schemas/tutorial" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:variable name="newId" select="/demo:ContactDB/demo:Contact[(@ContactId != '') and not(preceding-sibling::demo:Contact/@ContactId > @ContactId) and not(following-sibling::demo:Contact/@ContactId > @ContactId)]/@ContactId + 1" />


    <xsl:template match="demo:ContactDB">
        <xsl:copy>
            <xsl:copy-of select="@*"/>

            <xsl:for-each select="demo:Contact">
                <xsl:choose>
                    <xsl:when test="position() = last()">
                        <xsl:copy>
                            <xsl:copy-of select="@*[local-name() != 'ContactId']"/>

                            <xsl:attribute name="ContactId">
                                <xsl:value-of select="$newId"/>
                            </xsl:attribute>

                            <xsl:copy-of select="*"/>
                        </xsl:copy>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:copy-of select="." />
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:for-each>

        </xsl:copy>
    </xsl:template>



</xsl:stylesheet>
